Index: /LMDZ6/branches/cirrus/libf/phylmdiso/physiq_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmdiso/physiq_mod.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/phylmdiso/physiq_mod.F90	(revision 5202)
@@ -4515,4 +4660,45 @@
 
        IF (iflag_thermals>=1) THEN
+
+! Tests Fredho, instensibilite au pas de temps -------------------------------
+! A detruire en 2024 une fois les tests documentes et les choix faits        !
+          if (iflag_thermals_tenv /10 == 0 ) then                            !
+            do k=1,klev                                                      !
+               do i=1,klon                                                   !
+                  t_env(i,k)=t_seri(i,k)                                     !
+                  q_env(i,k)=q_seri(i,k)                                     !
+#ifdef ISO
+                  do ixt=1,ntraciso
+                        xt_env(ixt,i,k)=xt_seri(ixt,i,k)
+                  enddo
+#endif
+               enddo                                                         !
+            enddo                                                            !
+          else if (iflag_thermals_tenv / 10 == 2 ) then                      !
+            do k=1,klev                                                      !
+               do i=1,klon                                                   !
+                  q_env(i,k)=q_seri(i,k)                                     !
+#ifdef ISO
+                  do ixt=1,ntraciso
+                        xt_env(ixt,i,k)=xt_seri(ixt,i,k)
+                  enddo
+#endif
+               enddo                                                         !
+            enddo                                                            !
+          else if (iflag_thermals_tenv / 10 == 3 ) then                      !
+            do k=1,klev                                                      !
+               do i=1,klon                                                   !
+                  t_env(i,k)=t(i,k)                                          !
+                  q_env(i,k)=qx(i,k,1)                                       !
+#ifdef ISO
+                  do ixt=1,ntraciso
+                        xt_env(ixt,i,k)=xt_seri(ixt,i,k)
+                  enddo
+#endif
+               enddo                                                         !
+            enddo                                                            !
+          endif                                                              !
+! Tests Fredho, instensibilite au pas de temps ------------------------------
+
           !jyg<
 !!       IF (mod(iflag_pbl_split/2,2) .EQ. 1) THEN
@@ -4523,4 +4709,6 @@
                    t_therm(i,k) = t_seri(i,k) - wake_s(i)*wake_deltat(i,k)
                    q_therm(i,k) = q_seri(i,k) - wake_s(i)*wake_deltaq(i,k)
+                   t_env(i,k)   = t_env(i,k) - wake_s(i)*wake_deltat(i,k)
+                   q_env(i,k)   = q_env(i,k) - wake_s(i)*wake_deltaq(i,k)
                    u_therm(i,k) = u_seri(i,k)
                    v_therm(i,k) = v_seri(i,k)
@@ -4528,4 +4716,5 @@
                    do ixt=1,ntraciso
                      xt_therm(ixt,i,k) = xt_seri(ixt,i,k) - wake_s(i)*wake_deltaxt(ixt,i,k)
+                     xt_env(ixt,i,k) = xt_env(ixt,i,k) - wake_s(i)*wake_deltaxt(ixt,i,k)
                    enddo !do ixt=1,ntraciso
 #endif
@@ -4570,5 +4759,5 @@
                ,pplay,paprs,pphi,weak_inversion &
                         ! ,u_seri,v_seri,t_seri,q_seri,zqsat,debut & !jyg
-               ,u_therm,v_therm,t_therm,q_therm,t_therm,q_therm,zqsat,debut &  !jyg
+               ,u_therm,v_therm,t_therm,q_therm,t_env,q_env,zqsat,debut &  !jyg
                ,d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs &
                ,fm_therm,entr_therm,detr_therm &
@@ -4589,5 +4778,5 @@
                ,zqla,ztva &
 #ifdef ISO         
-     &      ,xt_therm,d_xt_ajs &
+     &      ,xt_env,d_xt_ajs &
 #ifdef DIAGISO         
      &      ,q_the,xt_the &
@@ -4624,5 +4813,5 @@
              IF (ok_bug_split_th) THEN
                CALL add_wake_tend &
-                   (d_deltat_the, d_deltaq_the, dsig0, ddens0, ddens0, wkoccur1, 'the', abortphy &
+                   (d_deltat_the, d_deltaq_the, dsig0, dsig0, ddens0, ddens0, wkoccur1, 'the', abortphy &
 #ifdef ISO
                    ,d_deltaxt_the &
@@ -4631,5 +4820,5 @@
              ELSE
                CALL add_wake_tend &
-                   (d_deltat_the, d_deltaq_the, dsig0, ddens0, ddens0, wake_k, 'the', abortphy &
+                   (d_deltat_the, d_deltaq_the, dsig0, dsig0, ddens0, ddens0, wake_k, 'the', abortphy &
 #ifdef ISO
                    ,d_deltaxt_the &
@@ -4660,8 +4849,7 @@
           ! Transport de la TKE par les panaches thermiques.
           ! FH : 2010/02/01
-          !     if (iflag_pbl.eq.10) then
-          !     call thermcell_dtke(klon,klev,nbsrf,pdtphys,fm_therm,entr_therm,
-          !    s           rg,paprs,pbl_tke)
-          !     endif
+               if (iflag_thermcell_tke==1) then
+               call thermcell_dtke(klon,klev,nbsrf,pdtphys,fm_therm,entr_therm,rg,paprs,pbl_tke)
+               endif
           ! -------------------------------------------------------------------
 
@@ -4902,13 +5090,15 @@
 
     CALL lscp(klon,klev,phys_tstep,missing_val,paprs,pplay, &
-         t_seri, q_seri,ptconv,ratqs, &
+         t_seri, q_seri,qs_ancien,ptconv,ratqs, &
          d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, rneblsvol, & 
-         pfraclr,pfracld, &
+         pfraclr, pfracld, cldfraliq, sigma2_icefracturb, mean_icefracturb,  &
          radocond, picefra, rain_lsc, snow_lsc, &
          frac_impa, frac_nucl, beta_prec_fisrt, &
          prfl, psfl, rhcl,  &
          zqasc, fraca,ztv,zpspsk,ztla,zthl,iflag_cld_th, &
-         iflag_ice_thermo, distcltop, temp_cltop, cell_area, &
-         cf_seri, rvc_seri, u_seri, v_seri, pbl_eps(:,:,is_ave), &
+         iflag_ice_thermo, distcltop, temp_cltop, 
+         pbl_tke(:,:,is_ave), pbl_eps(:,:,is_ave), &
+         cell_area, &
+         cf_seri, rvc_seri, u_seri, v_seri, &
          qsub, qissr, qcld, subfra, issrfra, gamma_cond, ratio_qi_qtot, &
          dcf_sub, dcf_con, dcf_mix, dqi_adj, dqi_sub, dqi_con, dqi_mix, &
@@ -4923,4 +5113,5 @@
     ELSE
 
+    ! Camille Risi mai 2024: on ne met pas à jour ici pour ne pas s'mbêter à modifier fisrtilp
     CALL fisrtilp(phys_tstep,paprs,pplay, &
          t_seri, q_seri,ptconv,ratqs, &
@@ -5522,5 +5713,5 @@
                      tausum_aero, tau3d_aero)
              ENDIF
-          ELSE                       ! RRTM radiation
+          ELSE IF (iflag_rrtm .EQ.1) THEN  ! RRTM radiation
              IF (aerosol_couple .AND. config_inca == 'aero' ) THEN
                 abort_message='config_inca=aero et rrtm=1 impossible'
@@ -5588,4 +5779,15 @@
                 !
              ENDIF
+          ELSE IF (iflag_rrtm .EQ.2) THEN    ! ecrad RADIATION
+#ifdef CPP_ECRAD
+             !--climatologies or INCA aerosols
+             CALL readaerosol_optic_ecrad( debut, aerosol_couple, ok_alw, ok_volcan, &
+                  flag_aerosol, flag_bc_internal_mixture, itap, jD_cur-jD_ref, &
+                  pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
+                  tr_seri, mass_solu_aero, mass_solu_aero_pi, m_allaer)
+#else
+                abort_message='You should compile with -rad ecrad if running with iflag_rrtm=2'
+                CALL abort_physic(modname,abort_message,1)
+#endif
           ENDIF
        ELSE   !--flag_aerosol = 0 
@@ -5828,5 +6030,5 @@
                ! Rajoute par OB pour RRTM
                tau_aero_lw_rrtm, & 
-               cldtaupirad, &
+               cldtaupirad, m_allaer, &
 !              zqsat, flwcrad, fiwcrad, &
                zqsat, flwc, fiwc, &
@@ -5907,5 +6109,5 @@
                                 ! Rajoute par OB pour RRTM
                      tau_aero_lw_rrtm, &
-                     cldtaupi, &
+                     cldtaupi, m_allaer, &
 !                    zqsat, flwcrad, fiwcrad, &
                      zqsat, flwc, fiwc, &
@@ -5934,4 +6136,52 @@
                      cloud_cover_sw)
           ENDIF !ok_4xCO2atm
+
+! A.I aout 2023
+! Effet 3D des nuages Ecrad
+! a passer : nom du ficher namelist et cles ok_3Deffect
+! a declarer comme iflag_rrtm et a lire dans physiq.def
+#ifdef CPP_ECRAD
+          IF (ok_3Deffect) then
+!                print*,'ok_3Deffect = ',ok_3Deffect  
+                namelist_ecrad_file='namelist_ecrad_s2'
+                CALL radlwsw &
+                     (debut, dist, rmu0, fract,  &
+                     paprs, pplay,zxtsol,SFRWL,albsol_dir, albsol_dif, &
+                     t_seri,q_seri,wo, &
+                     cldfrarad, cldemirad, cldtaurad, &
+                     ok_ade.OR.flag_aerosol_strat.GT.0, ok_aie,  ok_volcan, flag_volc_surfstrat, &
+                     flag_aerosol, flag_aerosol_strat, flag_aer_feedback, &
+                     tau_aero, piz_aero, cg_aero, &
+                     tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm, &
+                     tau_aero_lw_rrtm, &
+                     cldtaupi, &
+                     zqsat, flwc, fiwc, &
+                     ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
+                     namelist_ecrad_file, &
+! A modifier              
+                     heat_s2,heat0_s2,cool_s2,cool0_s2,albpla_s2, &
+                     heat_volc,cool_volc, &
+                     topsw_s2,toplw_s2,solsw_s2,solswfdiff_s2,sollw_s2, &
+                     sollwdown_s2, &
+                     topsw0_s2,toplw0_s2,solsw0_s2,sollw0_s2, &
+                     lwdnc0_s2, lwdn0_s2, lwdn_s2, lwupc0_s2, lwup0_s2, lwup_s2,  &
+                     swdnc0_s2, swdn0_s2, swdn_s2, swupc0_s2, swup0_s2, swup_s2, &
+                     topswad_aero_s2, solswad_aero_s2, &
+                     topswai_aero_s2, solswai_aero_s2, &
+                     topswad0_aero_s2, solswad0_aero_s2, &
+                     topsw_aero_s2, topsw0_aero_s2, &
+                     solsw_aero_s2, solsw0_aero_s2, &
+                     topswcf_aero_s2, solswcf_aero_s2, &
+                                !-C. Kleinschmitt for LW diagnostics
+                     toplwad_aero_s2, sollwad_aero_s2,&
+                     toplwai_aero_s2, sollwai_aero_s2, &
+                     toplwad0_aero_s2, sollwad0_aero_s2,&
+                                !-end
+                     ZLWFT0_i, ZFLDN0, ZFLUP0, &
+                     ZSWFT0_i, ZFSDN0, ZFSUP0, &
+                     cloud_cover_sw_s2)
+          ENDIF ! ok_3Deffect
+#endif
+
        ENDIF ! aerosol_couple
        itaprad = 0
@@ -6157,5 +6407,5 @@
        d_t_hin(:, :)=0.
        CALL add_phys_tend(du_gwd_hines, dv_gwd_hines, d_t_hin, dq0, dql0, &
-            dqi0, dqbs0,paprs, 'hin', abortphy,flag_inhib_tend,itap,0 &
+            dqi0, dqbs0, paprs, 'hin', abortphy,flag_inhib_tend,itap,0 &
 #ifdef ISO
      &    ,dxt0,dxtl0,dxti0 &
@@ -6280,5 +6530,5 @@
        
        SELECT CASE(flag_emit)
-       CASE(1) ! emission volc H2O dans LMDZ
+       CASE(1) ! emission volc H2O in LMDZ
           DO ieru=1, nErupt
              IF (year_cur==year_emit_vol(ieru).AND.&
@@ -6288,5 +6538,5 @@
                 
                 IF(flag_verbose_strataer) print *,'IN physiq_mod: date=',year_cur,mth_cur,day_cur
-                ! initialisation tendance q emission
+                ! initialisation of q tendency emission
                 d_q_emiss(:,:)=0.
                 ! daily injection mass emission - NL
@@ -6295,11 +6545,10 @@
                 !
                 CALL STRATEMIT(pdtphys,pdtphys,latitude_deg,longitude_deg,t_seri,&
-                     pplay,paprs,tr_seri,&
-                     m_H2O_emiss_vol_daily,&
-                     xlat_min_vol(ieru),xlat_max_vol(ieru),&
-                     xlon_min_vol(ieru),xlon_max_vol(ieru),&
-                     altemiss_vol(ieru),&
-                     sigma_alt_vol(ieru),1,&
-                     1,nAerErupt+1,0)
+                    pplay,paprs,tr_seri,&
+                    m_H2O_emiss_vol_daily,&
+                    xlat_min_vol(ieru),xlat_max_vol(ieru),&
+                    xlon_min_vol(ieru),xlon_max_vol(ieru),&
+                    altemiss_vol(ieru),sigma_alt_vol(ieru),1,1.,&
+                    nAerErupt+1,0)
                 
                 IF(flag_verbose_strataer) print *,'IN physiq_mod: min max d_q_emiss=',&
@@ -6315,5 +6564,4 @@
     ENDIF
 #endif
-
 
 !===============================================================
@@ -6754,46 +7002,106 @@
     t_seri(:,:)=t_seri(:,:)+d_t_ec(:,:)
 
-    !=======================================================================
-    !   SORTIES
-    !=======================================================================
-    !
-    !IM initialisation + calculs divers diag AMIP2
-    !
-    include "calcul_divers.h"
-    !
-    !IM Interpolation sur les niveaux de pression du NMC
-    !   -------------------------------------------------
-    !
-    include "calcul_STDlev.h"
-    !
-    ! slp sea level pressure derived from Arpege-IFS : CALL ctstar + CALL pppmer
-    CALL diag_slp(klon,t_seri,paprs,pplay,pphis,ptstar,pt0,slp)
-    !
+    !==================================================================
+    !--OB water mass fixer for the physics
+    !--water profiles are corrected to force mass conservation of water
+    !--currently flag is turned off
+    !==================================================================
+    IF (mass_fixer) THEN
+#ifdef ISO
+      CALL abort_gcm('physiq 6936','isos pas prevus dans le mass fixer',1)
+      ! Camille Risi mai 2024: on attend d'avoir la 4e dimension qui rendra tout plus simple.
+#endif
+    qql2(:)=0.0
+    DO k = 1, klev
+      qql2(:)=qql2(:)+(q_seri(:,k)+ql_seri(:,k))*zmasse(:,k)
+      IF (nqo >= 3) THEN
+        qql2(:)=qql2(:)+qs_seri(:,k)*zmasse(:,k)
+      ENDIF
+      IF (ok_bs) THEN
+        qql2(:)=qql2(:)+qbs_seri(:,k)*zmasse(:,k)
+      ENDIF
+    ENDDO
+
+#ifdef CPP_StratAer
+    IF (ok_qemiss) THEN
+       DO k = 1, klev
+          qql1(:) = qql1(:)+d_q_emiss(:,k)*zmasse(:,k)
+       ENDDO
+    ENDIF
+#endif
+    IF (ok_qch4) THEN
+       DO k = 1, klev
+          qql1(:) = qql1(:)+d_q_ch4_dtime(:,k)*zmasse(:,k)
+       ENDDO
+    ENDIF
+    
+    DO i = 1, klon
+      !--compute ratio of what q+ql should be with conservation to what it is
+      IF (ok_bs) THEN
+        corrqql=(qql1(i)+(evap(i)-rain_fall(i)-snow_fall(i)-bs_fall(i))*pdtphys)/qql2(i)
+      ELSE
+        corrqql=(qql1(i)+(evap(i)-rain_fall(i)-snow_fall(i))*pdtphys)/qql2(i)
+      ENDIF
+      DO k = 1, klev
+        q_seri(i,k) =q_seri(i,k)*corrqql
+        ql_seri(i,k)=ql_seri(i,k)*corrqql
+        IF (nqo >= 3) THEN
+          qs_seri(i,k)=qs_seri(i,k)*corrqql
+        ENDIF
+        IF (ok_bs) THEN
+          qbs_seri(i,k)=qbs_seri(i,k)*corrqql
+        ENDIF
+      ENDDO
+    ENDDO
+    ENDIF
+    !--fin mass fixer
+
     !cc prw  = eau precipitable
     !   prlw = colonne eau liquide 
     !   prlw = colonne eau solide
     !   prbsw = colonne neige soufflee
+    !   water_budget = non-conservation residual from the LMDZ physics
+    !                  (should be equal to machine precision if mass fixer is activated)
     prw(:) = 0.
     prlw(:) = 0.
     prsw(:) = 0.
     prbsw(:) = 0.
+    water_budget(:) = 0.0
     DO k = 1, klev
        prw(:)  = prw(:)  + q_seri(:,k)*zmasse(:,k)
        prlw(:) = prlw(:) + ql_seri(:,k)*zmasse(:,k)
-       prsw(:) = prsw(:) + qs_seri(:,k)*zmasse(:,k)
-       prbsw(:)= prbsw(:) + qbs_seri(:,k)*zmasse(:,k)
+       water_budget(:) = water_budget(:) + (q_seri(:,k)-qx(:,k,ivap)+ql_seri(:,k)-qx(:,k,iliq))*zmasse(:,k)
+       IF (nqo >= 3) THEN
+         prsw(:) = prsw(:) + qs_seri(:,k)*zmasse(:,k)
+         water_budget(:) = water_budget(:) + (qs_seri(:,k)-qx(:,k,isol))*zmasse(:,k)
+       ENDIF
+       IF (nqo >= 4 .AND. ok_bs) THEN
+         prbsw(:)= prbsw(:) + qbs_seri(:,k)*zmasse(:,k)
+         water_budget(:) = water_budget(:) + (qbs_seri(:,k)-qx(:,k,ibs))*zmasse(:,k)
+       ENDIF
     ENDDO
-
-#ifdef ISO
-      DO i = 1, klon
-      do ixt=1,ntraciso
-       xtprw(ixt,i) = 0. 
-       DO k = 1, klev
-        xtprw(ixt,i) = xtprw(ixt,i) + &
-     &           xt_seri(ixt,i,k)*(paprs(i,k)-paprs(i,k+1))/RG
-       ENDDO !DO k = 1, klev
-      enddo !do ixt=1,ntraciso
-      enddo !DO i = 1, klon
-#endif
+    water_budget(:)=water_budget(:)+(rain_fall(:)+snow_fall(:)-evap(:))*pdtphys
+    IF (ok_bs) THEN
+      water_budget(:)=water_budget(:)+bs_fall(:)*pdtphys
+    ENDIF
+    ! Camille Risi mai 2024: pour les isotopes, on attend d'avoir la 4e dimension, ça rendra tout plus facile
+    ! ces variables sont diagnostiques, donc pas indispensables
+
+    !=======================================================================
+    !   SORTIES
+    !=======================================================================
+    !
+    !IM initialisation + calculs divers diag AMIP2
+    !
+    include "calcul_divers.h"
+    !
+    !IM Interpolation sur les niveaux de pression du NMC
+    !   -------------------------------------------------
+    !
+    include "calcul_STDlev.h"
+    !
+    ! slp sea level pressure derived from Arpege-IFS : CALL ctstar + CALL pppmer
+    CALL diag_slp(klon,t_seri,paprs,pplay,pphis,ptstar,pt0,slp)
+    !
     !
     IF (ANY(type_trac == ['inca','inco'])) THEN
@@ -6898,53 +7206,4 @@
     !IM global posePB      include "write_bilKP_ave.h"
     !
-
-    !--OB mass fixer 
-    !--profile is corrected to force mass conservation of water
-    IF (mass_fixer) THEN
-    qql2(:)=0.0
-    DO k = 1, klev
-      qql2(:)=qql2(:)+(q_seri(:,k)+ql_seri(:,k)+qs_seri(:,k))*zmasse(:,k)
-    ENDDO
-    
-#ifdef CPP_StratAer
-    IF (ok_qemiss) THEN
-       DO k = 1, klev
-          qql1(:) = qql1(:)+d_q_emiss(:,k)*zmasse(:,k)
-       ENDDO
-    ENDIF
-#endif
-    IF (ok_qch4) THEN
-       DO k = 1, klev
-          qql1(:) = qql1(:)+d_q_ch4_dtime(:,k)*zmasse(:,k)
-       ENDDO
-    ENDIF
-    
-    DO i = 1, klon
-      !--compute ratio of what q+ql should be with conservation to what it is
-      corrqql=(qql1(i)+(evap(i)-rain_fall(i)-snow_fall(i))*pdtphys)/qql2(i)
-      DO k = 1, klev
-        q_seri(i,k) =q_seri(i,k)*corrqql
-        ql_seri(i,k)=ql_seri(i,k)*corrqql
-      ENDDO
-    ENDDO
-#ifdef ISO
-    do ixt=1,ntraciso
-    xtql2(ixt,:)=0.0
-    DO k = 1, klev
-      xtql2(ixt,:)=xtql2(ixt,:)+(xt_seri(ixt,:,k)+xtl_seri(ixt,:,k)+xts_seri(ixt,:,k))*zmasse(:,k)
-    ENDDO
-    DO i = 1, klon
-      !--compute ratio of what q+ql should be with conservation to what it is
-      corrxtql(ixt)=(xtql1(ixt,i)+(xtevap(ixt,i)-xtrain_fall(ixt,i)-xtsnow_fall(ixt,i))*pdtphys)/xtql2(ixt,i)
-      DO k = 1, klev
-        xt_seri(ixt,i,k) =xt_seri(ixt,i,k)*corrxtql(ixt)
-        xtl_seri(ixt,i,k)=xtl_seri(ixt,i,k)*corrxtql(ixt)
-      ENDDO
-    ENDDO   
-    enddo !do ixt=1,ntraciso 
-#endif
-    ENDIF
-    !--fin mass fixer
-
     ! Sauvegarder les valeurs de t et q a la fin de la physique:
     !
@@ -6962,4 +7221,5 @@
     xtl_ancien(:,:,:)=xtl_seri(:,:,:)
     xts_ancien(:,:,:)=xts_seri(:,:,:)
+    xtbs_ancien(:,:,:)=xtbs_seri(:,:,:)
 #endif
     CALL water_int(klon,klev,q_ancien,zmasse,prw_ancien)
@@ -7098,63 +7358,16 @@
          ok_sync, ptconv, read_climoz, clevSTD,          &
          ptconvth, d_u, d_t, qx, d_qx, zmasse,           &
-         flag_aerosol, flag_aerosol_strat, ok_cdnc,t,u1,v1)
+         flag_aerosol, flag_aerosol_strat, ok_cdnc,t, u1, v1)
 #endif
 
 #ifndef CPP_XIOS
-    CALL write_paramLMDZ_phy(itap,nid_ctesGCM,ok_sync)
-#endif
-
-#endif
-
-! Pour XIOS : On remet des variables a .false. apres un premier appel
-    IF (debut) THEN
-
-      IF (using_xios) THEN
-        swaero_diag=.FALSE.
-        swaerofree_diag=.FALSE.
-        dryaod_diag=.FALSE.
-        ok_4xCO2atm= .FALSE.
-!       write (lunout,*)'ok_4xCO2atm= ',swaero_diag, swaerofree_diag, dryaod_diag, ok_4xCO2atm
-
-        IF (is_master) THEN
-          !--setting up swaero_diag to TRUE in XIOS case 
-          IF (xios_field_is_active("topswad").OR.xios_field_is_active("topswad0").OR. & 
-             xios_field_is_active("solswad").OR.xios_field_is_active("solswad0").OR. & 
-             xios_field_is_active("topswai").OR.xios_field_is_active("solswai").OR.  & 
-               (iflag_rrtm==1.AND.(xios_field_is_active("toplwad").OR.xios_field_is_active("toplwad0").OR. & 
-                                   xios_field_is_active("sollwad").OR.xios_field_is_active("sollwad0"))))  & 
-             !!!--for now these fields are not in the XML files so they are omitted 
-             !!!  xios_field_is_active("toplwai").OR.xios_field_is_active("sollwai") !))) & 
-             swaero_diag=.TRUE. 
-
-          !--setting up swaerofree_diag to TRUE in XIOS case 
-          IF (xios_field_is_active("SWdnSFCcleanclr").OR.xios_field_is_active("SWupSFCcleanclr").OR. &
-             xios_field_is_active("SWupTOAcleanclr").OR.xios_field_is_active("rsucsaf").OR.   &
-             xios_field_is_active("rsdcsaf") .OR. xios_field_is_active("LWdnSFCcleanclr").OR. &
-             xios_field_is_active("LWupTOAcleanclr")) &
-             swaerofree_diag=.TRUE. 
-
-          !--setting up dryaod_diag to TRUE in XIOS case 
-          DO naero = 1, naero_tot-1
-           IF (xios_field_is_active("dryod550_"//name_aero_tau(naero))) dryaod_diag=.TRUE. 
-          ENDDO
-          !
-          !--setting up ok_4xCO2atm to TRUE in XIOS case 
-          IF (xios_field_is_active("rsut4co2").OR.xios_field_is_active("rlut4co2").OR. & 
-             xios_field_is_active("rsutcs4co2").OR.xios_field_is_active("rlutcs4co2").OR. &
-             xios_field_is_active("rsu4co2").OR.xios_field_is_active("rsucs4co2").OR. &
-             xios_field_is_active("rsd4co2").OR.xios_field_is_active("rsdcs4co2").OR. &
-             xios_field_is_active("rlu4co2").OR.xios_field_is_active("rlucs4co2").OR. &
-             xios_field_is_active("rld4co2").OR.xios_field_is_active("rldcs4co2")) &
-             ok_4xCO2atm=.TRUE. 
-        ENDIF
-        !$OMP BARRIER
-        CALL bcast(swaero_diag)
-        CALL bcast(swaerofree_diag)
-        CALL bcast(dryaod_diag)
-        CALL bcast(ok_4xCO2atm)
-!        write (lunout,*)'ok_4xCO2atm= ',swaero_diag, swaerofree_diag, dryaod_diag, ok_4xCO2atm
-      ENDIF !using_xios
-    ENDIF
+      CALL write_paramLMDZ_phy(itap,nid_ctesGCM,ok_sync)
+#endif
+
+#endif
+    ! Petit appelle de sorties pour accompagner le travail sur phyex
+    if ( iflag_physiq == 1 ) then
+        call output_physiqex(debut,jD_eq,pdtphys,presnivs,paprs,u,v,t,qx,cldfra,0.*t,0.*t,0.*t,pbl_tke,theta)
+    endif
 
     !====================================================================
@@ -7200,4 +7413,5 @@
     ! Disabling calls to the prt_alerte function
     alert_first_call = .FALSE.
+
     
     IF (lafin) THEN
@@ -7212,22 +7426,25 @@
          IF (read_climoz >= 1) THEN
            IF (is_mpi_root) CALL nf95_close(ncid_climoz)
-            DEALLOCATE(press_edg_climoz) ! pointer
-            DEALLOCATE(press_cen_climoz) ! pointer
+            DEALLOCATE(press_edg_climoz)
+            DEALLOCATE(press_cen_climoz)
          ENDIF
        
        ENDIF
+
+       IF (using_xios) THEN
+
+#ifdef INCA
+          IF (type_trac == 'inca') THEN 
+             IF (is_omp_master .AND. grid_type==unstructured) THEN 
+                CALL finalize_inca
+             ENDIF
+          ENDIF
+#endif
+
+          IF (is_omp_master .and. grid_type==unstructured) CALL xios_context_finalize
+       ENDIF
+
+       WRITE(lunout,*) ' physiq fin, nombre de steps ou cvpas = 1 : ', Ncvpaseq1
        
-       IF (using_xios) THEN
-         IF (is_omp_master) CALL xios_context_finalize
-
-#ifdef INCA
-         if (type_trac == 'inca') then 
-            IF (is_omp_master .and. grid_type==unstructured) THEN 
-               CALL finalize_inca
-            ENDIF
-         endif
-#endif
-       ENDIF !using_xios
-       WRITE(lunout,*) ' physiq fin, nombre de steps ou cvpas = 1 : ', Ncvpaseq1
     ENDIF
 
Index: /LMDZ6/branches/cirrus/libf/phylmdiso/physiqex_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/phylmdiso/physiqex_mod.F90	(revision 5202)
+++ /LMDZ6/branches/cirrus/libf/phylmdiso/physiqex_mod.F90	(revision 5202)
@@ -0,0 +1,1 @@
+link ../phylmd/physiqex_mod.F90
